const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const platform_metrics = sequelize.define(
    'platform_metrics',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      region: {
        type: DataTypes.TEXT,
      },

      api_latency_ms: {
        type: DataTypes.DECIMAL,
      },

      uptime_pct: {
        type: DataTypes.DECIMAL,
      },

      page_load_ms: {
        type: DataTypes.DECIMAL,
      },

      timestamp: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  platform_metrics.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.platform_metrics.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.platform_metrics.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.platform_metrics.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.platform_metrics.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return platform_metrics;
};
